%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% FI:PA171 - Digital Filters
%
% topic: Wavelet analysis
% author: David Svoboda <svoboda@fi.muni.cz>
%         Masaryk University (c) 2019
% note: designed for Matlab
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%-----------------------------------------
% Conversion from filters to wavelets
%-----------------------------------------

% Try to depict various scaling and wavelet functions
[LoD, HiD, LoR, HiR] = wfilters('db2');
ShowWavelets(LoR);

% Show progress of Cascade algorithm
Cascade(LoR);

% load the sample image
I = imread('brain.tif');

%-----------------------------------------------
% Discrete wavelet transform in 1D (n-th level)
%-----------------------------------------------

n = 3;
figure;
line = I(128,:);
subplot(211);
plot(line);
title('Input 1d signal');
[LoD, HiD, LoR, HiR] = wfilters('haar');
dwtmode('per');
[C,L]=wavedec(double(line), n, LoD, HiD);
subplot(212);
plot(C);
title('FTW of input signal');

%-----------------------------------------------------------------------
% Task A
%-----------------------------------------------------------------------
%
% Implement one level of fast wavelet transform, i.e. one level of signal
% decomposition and one level of signal reconstruction:
%
% function [approx, detail] = fwt_1d_one_level(signal, low, high)
%
% function signal = ifwt_1d_one_level(approx, detail, low, high)

%-----------------------------------------------------------------------
% Task B
%-----------------------------------------------------------------------
%
% Given two nearly identical images with different focal plane and
% different depth of field fuse them together to get one sharp image.
% Complete the code in script 'fusion.m' to enable execution of the
% following command:
%
% >> fusion('imageA.jpg','imageB.jpg')
%
% Tip: Perform wavelet decomposition of each image and combine the results
% using the maximal filter (sharper area corresponds to more intense 
% edges, i.e. to detail coefficients with higher amplitudes).