function [scaling_function, wavelet_function] = ShowWavelets(filter_prototype)

figure;
c = filter_prototype;

% TAKE THE PROTOTYPE (LOW-PASS RECONSTRUCTION FILTER)
finer_c = c;

% PREPARE THE HIGH-PASS RECONSTRUCTION FILTER
% change order
rev_c = c(end:-1:1);
% multiply every even sample by -1
rev_c(2:2:end) = rev_c(2:2:end)*(-1);
% upsample
finer_d = myupsample(rev_c);

% TRY 10 ITERATIONS
for iter=1:10 
    old_c = finer_c;
    old_d = finer_d;
    finer_c = conv(myupsample(old_c),c);
    finer_d = conv(myupsample(old_d),c);
end

% PLOT THE SOLUTION
subplot(121);
plot(finer_c);
title('Scaling function');
subplot(122);
plot(finer_d);
title('Wavelet function');

scaling_function = finer_c;
wavelet_function = finer_d;
end


function extended_vector = myupsample(vector)
    extended_vector(1:2:2*length(vector)) = vector(:);
end

